<?php

/*
Plugin Name: Limit Posts
Plugin URI: http://labitacora.net/comunBlog/limit-post.phps
Description: Limits the displayed text length on the index page entries and generates a link to a page to read the full content if its bigger than the selected maximum length.
Usage: the_content_limit($max_charaters, $more_link)
Version: 1.1
Author: Alfonso S�nchez-Paus D�az y Juli�n Sim�n de Castro
Author URI: http://labitacora.net/
License: GPL
Download URL: http://labitacora.net/comunBlog/limit-post.phps
Make:
    In file index.php
    replace the_content()
    with the_content_limit(1000, "more")
*/

function the_content_limit($max_char, $more_link_text = '(more...)', $stripteaser = 0, $more_file = '') {
    $content = get_the_content($more_link_text, $stripteaser, $more_file);
    $content = apply_filters('the_content', $content);
    $content = str_replace(']]>', ']]&gt;', $content);

   if (strlen($_GET['p']) > 0) {
      echo $content;
   }
   else if ((strlen($content)>$max_char) && ($espacio = strpos($content, " ", $max_char ))) {
        $content = substr($content, 0, $espacio);
        $content = $content;
        echo $content;
        echo "<a href='";
        the_permalink();
        echo "'>"."..."."</a>";
        echo "<br /><br />";
        echo "<a href='";
        the_permalink();
        echo "'>".$more_link_text."</a></p>";
   }
   else {
      echo $content;
   }
}



/*
Plugin Name: Weighted Categories
Plugin URI: http://hitormiss.org/archives/2004/12/20/weighted-categories-list-in-wordpress/
Description: Template tag to display a weighted list of category links
Version: 1.2
Author: Matt Kingston
Author URI: http://www.hitormiss.org/
*/
function weighted_categories($smallest=10, $largest=48, $unit="pt", $exclude='')
{
	$cats = list_cats(1, 'all', 'name', 'asc', '', 0, 0, 1, 1, 0, 1, 1, 0, 1, '', '', $exclude, 0);

	$cats = explode("\n", $cats);
	foreach ($cats as $cat)
	{
		eregi("a href=\"(.+)\" ", $cat, $regs);
		$catlink = $regs[1];
		$cat = trim(strip_tags($cat));
		eregi("(.*) \(([0-9]+)\)$", $cat, $regs);
		$catname = $regs[1]; $count = $regs[2];
		$counts{$catname} = $count;
		$catlinks{$catname} = $catlink;
	}
	$spread = max($counts) - min($counts); 
	if ($spread <= 0) { $spread = 1; };
	$fontspread = $largest - $smallest;
	$fontstep = $spread / $fontspread;
	if ($fontspread <= 0) { $fontspread = 1; }
	foreach ($counts as $catname => $count)
	{
		$catlink = $catlinks{$catname};
		print "<a href=\"$catlink\" title=\"$count entries\" style=\"font-size: ".
		($smallest + ($count/$fontstep))."$unit;\">$catname</a> \n";
	}
}


/*
Plugin Name: Brian's Latest Comments
Plugin URI: http://meidell/latestcomments/
Version: 1.5.10
Description: This shows an overview of the recently active articles and the last people to comment on them. Original idea and code fixes contributed by <a href="http://binarybonsai.com">Michael Heilemann</a>.<br />If you have <a href="http://binarybonsai.com/archives/2004/08/17/time-since-plugin/">Dunstan's Time Since</a> installed, this plugin uses it for the title="" attributes on the comments and posts. (For WordPress 1.5)
Author: Brian Meidell
Author URI: http://meidell.dk/blog

Version 1.5: 	Now works without LOCK TABLE and CREATE TEMPORARY TABLE priviledges.
Version 1.5.1:  Can't remember what I did here
Version 1.5.2: 	Fixed count select statement to not include spammy comments
Version 1.5.3: 	Properly excludes track- and pingbacks
Version 1.5.4:  Excludes posts that are not published, even if they have comments
Version 1.5.5:	Fade old comments, fixed bug that wreaked havoc with Time Since
Version 1.5.6:	Bugfix from Jonas Rabbe (http://www.jonas.rabbe.com/) pertaining to timesince
Version 1.5.7:	Bugfix so old colors can be darker than new colors (stupid oversight), thanks to http://spiri.dk for spotting it.
		Bugfix where single digit hex would cause invalid colors, thanks to http://www.wereldkeuken.be/ for the fix.
Version 1.5.8:	Bugfix from Matthias Schutz regarding time_since.
Version 1.5.9:  Added function redefiniotion protection if people use the plugin in several places
Version 1.5.10:	Added bugfix by http://cavemonkey50.com
		Added time_since bugfix from http://getk2.com/forum/showthread.php?t=449

*/ 

function blc_latest_comments($num_posts = 5, $num_comments = 6, $hide_pingbacks_and_trackbacks = true, $prefix = "<li class='alternate'>", $postfix = "</li>", $fade_old = true, $range_in_days = 10, $new_col = "#999999", $old_col = "#999999")
{
	global $wpdb, $tablecomments, $tableposts;

	if(!function_exists('blc_clamp'))
	{
		function blc_clamp($min, $max, $val) 
		{
			return max($min,min($max,$val));
		}
	}

	function get_channel($col, $offset)
	{
		return hexdec(substr($col, $offset, 2));
	}

	function channels($col)
	{
		$r = get_channel($col, 1);
		$g = get_channel($col, 3);
		$b = get_channel($col, 5);
		return array($r, $g, $b);
	}

	$max_time = $range_in_days * 24 * 60 * 60 ; 

	function scale_channel($old, $new, $diff, $max_time)
	{
		$range = $old - $new;
		$c = round($diff/$max_time*($range))+$new; 
		$c = blc_clamp(min($new, $old), max($new, $old), $c);
		$c_hex = str_pad(dechex($c), 2, '0', STR_PAD_LEFT);
		return $c_hex;
	}

	$usetimesince = function_exists('time_since'); // Work nicely with Dunstan's Time Since plugin (adapted by Michael Heilemann)

	// This is compensating for the lack of subqueries in mysql 3.x
	// The approach used in previous versions needed the user to
	// have database lock and create tmp table priviledges. 
	// This uses more queries and manual DISTINCT code, but it works with just select privs.
	if(!$hide_pingbacks_and_trackbacks)
		$ping = "";
	else
		$ping = "AND comment_type<>'pingback' AND comment_type<>'trackback'";
	$posts = $wpdb->get_results("SELECT 
		comment_post_ID, post_title 
		FROM ($tablecomments LEFT JOIN $tableposts ON (comment_post_ID = ID))
		WHERE comment_approved = '1' 
		AND ($tableposts.post_status='publish' OR $tableposts.post_status='static')
		$ping
		ORDER BY comment_date DESC;");
		
	$seen = array();	
	$num = 0;

	if($fade_old)
	{
		list($r_new, $g_new, $b_new) = channels($new_col);
		list($r_old, $g_old, $b_old) = channels($old_col);
	}
	
	foreach($posts as $post)
	{
		// The following 5 lines is a manual DISTINCT and LIMIT,
		// since mysql 3.x doesn't allow you to control which way a DISTINCT
		// select merges multiple entries.
		if(array_key_exists($post->comment_post_ID, $seen))
			continue;
		$seen[$post->comment_post_ID] = true;	
		if($num++ > $num_posts)
			break;
		
		$commenters = $wpdb->get_results("SELECT *, UNIX_TIMESTAMP(comment_date) AS unixdate FROM $tablecomments
	       			WHERE comment_approved = '1'
				AND comment_post_ID = '".$post->comment_post_ID."'
				$ping
				ORDER BY comment_date DESC
				LIMIT $num_comments;");

		$count = $wpdb->get_var("SELECT COUNT(comment_ID) AS c FROM $tablecomments WHERE comment_post_ID = $post->comment_post_ID AND comment_approved = '1' ".$ping);
		$i = 0;
		$link = get_permalink($post->comment_post_ID);
		if($usetimesince)
			//$title = " title=\"Last comment was ".time_since($commenters[0]->unixdate)." ago\"";
			$title = " title=\"Last comment was ".time_since(strtotime($commenters[0]->comment_date_gmt." GMT"),time())." ago\"";
		else
			$title  = "";
		echo $prefix."<a href=\"".$link."\"$title class=\"activityentry\">".stripslashes($post->post_title). "</a>&nbsp;&nbsp;<a href=\"$link#comments\" title=\"Go to the comments of this entry\">".$count."</a><br />\n<small>";
		foreach($commenters as $commenter)
		{
			if($usetimesince)
			//	$title = " title=\"Posted ".time_since($commenter->unixdate)." ago\"";
				$title = " title=\"Posted ".time_since(strtotime($commenter->comment_date_gmt." GMT"), time())." ago\""; 

			if($fade_old)
			{
				$diff = time() - $commenter->unixdate;
				$r_hex = scale_channel($r_old, $r_new, $diff, $max_time);
				$g_hex = scale_channel($g_old, $g_new, $diff, $max_time);
				$b_hex = scale_channel($b_old, $b_new, $diff, $max_time);
				$colstr = " style=\"color: #".$r_hex.$g_hex.$b_hex.";\"";
			}

			if($i++ > 0)
				echo ", ";
		
			echo "<a$colstr href=\"".$link . "#comment-" . $commenter->comment_ID."\"$title>".stripslashes($commenter->comment_author)."</a>";
		}
		if($count > $num_comments) 
			echo " <a href=\"$link#comments\" title=\"Go to the comments of this entry\">[...]</a>";
		echo "</small>".$postfix."\n";

	}
}

/* 
Plugin Name: Sideblog Wordpress Plugin
Plugin URI: http://katesgasis.com/2005/10/24/sideblog/
Description: A simple aside plugin. <br/>Licensed under the <a href="http://www.fsf.org/licensing/licenses/gpl.txt">GPL</a>
Version: 3.4
Author: Kates Gasis
Author URI: http://katesgasis.com
*/


$sb_defaultformat = "<li>%content% - %permalink%</li>";
$sb_defaultposts = 3;

function sideblog_where($query) {
	$sideblog_options = get_option('sideblog_options');
	
	if(is_home()){
		if($sideblog_options['setaside']){
			$query .= " AND category_id NOT IN (" . implode(",", $sideblog_options['setaside']) . ") ";
		}		
	} else if(is_feed()){
		if($sideblog_options['excludefromfeeds']){
			$query .= " AND category_id NOT IN (" . implode(",", $sideblog_options['excludefromfeeds']) . ") ";
		}		
	}
	return $query;

}

function sideblog_join($query) {
	global $wpdb;
	if(is_home()||is_feed()){
		if(!is_category()){
			$query .= " LEFT JOIN $wpdb->post2cat ON ($wpdb->posts.ID = $wpdb->post2cat.post_id) ";
		}
	}
	return $query;
}

function sideblog($asidecategory=''){
	global $wpdb, $sb_defaultformat,$sb_defaultposts;
	$limit = 5;
	$sideblog_options = get_option('sideblog_options');
	
	if(!isset($asidecategory) || empty($asidecategory)) {
		echo "Aside category not selected. Please provide a category slug if you're using non-dynamic sidebar.";
		return;
	}

	if(!$asidecategory){
		$asidecount = count($sideblog_options['setaside']);
		if($asidecount < 1){
			echo "No aside category selected. Please select an aside category in Options &raquo; Sideblog Panel.";
			return;
		}
		$asideid = '';
		if($sideblog_options['setaside']){
			foreach($sideblog_options['setaside'] as $aside){
				if($asideid!=''){
					break;
				}
				$asideid = $aside;
			}
		}
	} else {
		$asideid = $wpdb->get_var("SELECT cat_ID FROM $wpdb->categories WHERE category_nicename='{$asidecategory}'");
		if($sideblog_options['setaside']){
			if(!in_array($asideid,$sideblog_options['setaside'])){
				echo "Aside category not selected.";
				return;
			}
		}
	}
	$asidecategory = $asideid;
	$limit = $sideblog_options['numentries'][$asideid];
	if(!$limit){
		$limit = $sb_defaultposts;
	}

	$displayformat = stripslashes($sideblog_options['displayformat'][$asideid]);
	if(!$displayformat){
		$displayformat = $sb_defaultformat;
	}
	
	$now = current_time('mysql');
	$sideblog_contents = $wpdb->get_results("SELECT $wpdb->posts.ID, $wpdb->posts.post_title, $wpdb->posts.post_content, $wpdb->posts.post_date FROM $wpdb->posts, $wpdb->post2cat WHERE $wpdb->posts.ID = $wpdb->post2cat.post_id AND $wpdb->post2cat.category_id={$asidecategory} AND $wpdb->posts.post_status='publish' AND $wpdb->posts.post_password='' AND $wpdb->posts.post_date < '" . $now . "' ORDER BY $wpdb->posts.post_date DESC LIMIT " . $limit);
	
	$patterns[] = "%title%";
	$patterns[] = "%content%";
	$patterns[] = "%permalink%";
	$patterns[] = "%title_url%";
	$patterns[] = "%postdate%";
	$patterns[] = "%postdate_url%";
	$patterns[] = "%excerpt%";

	preg_match("/\%excerpt\_\d+\%/",$displayformat,$matches);
	$patterns[] = $matches[0];
	
	preg_match("/\d+/",$matches[0],$excerptcut);
	
	if($sideblog_contents){
		foreach($sideblog_contents as $sideblog_content){			
			$permalink = get_permalink($sideblog_content->ID);

		

			$excerpt = sideblog_excerpt($sideblog_content->post_content,15);
			$excerpt2 = sideblog_excerpt($sideblog_content->post_content,$excerptcut[0]);

			$replacements[] = $sideblog_content->post_title;
			$replacements[] = $sideblog_content->post_content;
			$replacements[] = "<a href=\"{$permalink}\">#</a>";
			$replacements[] = "<a href=\"{$permalink}\" title=\"{$sideblog_content->post_title}\">{$sideblog_content->post_title}</a>";
			$replacements[] = $sideblog_content->post_date;
			$replacements[] = "<a href=\"{$permalink}\">{$sideblog_content->post_date}</a>";
			$replacements[] = $excerpt;
			$replacements[] = $excerpt2;
			echo str_replace($patterns,$replacements,$displayformat);
			unset($replacements);
		}
	}
}

function sideblog_option_page(){
	global $wpdb, $sb_defaultformat, $sb_defaultposts;
	if(isset($_POST['op'])){
		update_option('sideblog_options',$_POST['sideblog_options']);
		echo "<div id=\"message\" class=\"updated fade\"><p>Sideblog Options Updated</p></div>\n";

	}
	$sideblog_options = get_option('sideblog_options');
	
	$rows = $wpdb->get_results("SELECT cat_ID as id, cat_name as name, category_nicename as slug FROM {$wpdb->categories} ORDER BY cat_name");
	
	$catlist = "";
	if($rows) {
		$alt = true;
		foreach($rows as $row) {
			if($alt) {
				$class="class='alternate'";
				$alt = false;
			}else{
				$class="class=''";
				$alt = true;
			}

			$excludefromfeeds = "";
			if(isset($sideblog_options['excludefromfeeds'][$row->id])){
				$excludefromfeeds = "checked='checked'";
			}

			$setaside = "";
			if(isset($sideblog_options['setaside'][$row->id])){
				$setaside = "checked='checked'";
			}
	
			$numentries = "";
			$postno = isset($sideblog_options['numentries'][$row->id]) ? $sideblog_options['numentries'][$row->id] : '';
			if(trim($postno)==''){
				for($i=1;$i<=$sb_defaultposts;$i++){
					if($postno == $i){
						$numentries .= "<option value=\"{$i}\" selected='true' >{$i}</option>\n";
					} else {
						$numentries .= "<option value=\"{$i}\">{$i}</option>\n";
					}
				}
			} else {
				for($i=1;$i<=$sb_defaultposts;$i++){
					if($postno == $i){
						$numentries .= "<option value=\"{$i}\" selected='true' >{$i}</option>\n";
					} else {
						$numentries .= "<option value=\"{$i}\">{$i}</option>\n";
					}
				}
			}

			$displayformat = isset($sideblog_options['displayformat'][$row->id]) ? $sideblog_options['displayformat'][$row->id]: '' ;
			if(trim($displayformat)==''){
				$displayformat = $sb_defaultformat;
			}

			$displayformat = htmlspecialchars(stripslashes($displayformat));

			$catlist .= "<tr $class>\n<td align='center'><input type=\"checkbox\" name=\"sideblog_options[setaside][{$row->id}]\" value=\"{$row->id}\" {$setaside}/></td>\n";
			$catlist .= "<td>{$row->name}</td>\n";
			$catlist .= "<td>{$row->slug}</td>\n";
			$catlist .= "<td align='center'><input type=\"text\" name=\"sideblog_options[displayformat][{$row->id}]\" value=\"{$displayformat}\" style=\"width:90%;\"/></td>\n";
			$catlist .= "<td align='center'><select name=\"sideblog_options[numentries][{$row->id}]\">{$numentries}</select></td>";
			$catlist .= "<td align='center'><input type=\"checkbox\" name=\"sideblog_options[excludefromfeeds][{$row->id}]\" value=\"{$row->id}\" {$excludefromfeeds}/></td>\n</tr>\n";
		}
	}
	
	echo '
		<div class="wrap">
			<h2>' . __('Sideblog','sideblog') . '</h2>
			<form name="sideblog_options" method="POST">
				<input type="hidden" name="sideblog_options_update" value="update" />
				<fieldset class="options">
					<table width="100%" cellpadding="10px">
						<tr>
							<th width="8%">Select Categories
							</th>
							<th width="15%">Category Name
							</th>
							<th width="15%">Category Slug
							</th>
							<th>Display Format
							</th>	
							<th width="8%">Number of Entries
							</th>
							<th width="8%">Exclude from Feeds
							</th>
						</tr>
						' . $catlist . '
					</table>
				</fieldset>
				<p class="submit"><input type="submit" value="Update Sideblog Options"/></p>
				<input type="hidden" name="op" value="update"/>
				<legend>Display Format Tags</legend>
					<ul>
					<li>%title%</li>
					<li>%title_url%</li>
					<li>%content%</li>
					<li>%permalink%</li>
					<li>%postdate%</li>
					<li>%postdate_url%</li>
					</ul>
			</form>
		</div>';
}


function sideblog_add_option_page() {
	add_options_page('Sideblog','Sideblog',9,basename(__FILE__),'sideblog_option_page');
}

function sideblog_install(){
	add_option('sideblog_options');
	//add_option('widget_sideblog');
}

function sideblog_uninstall(){
	delete_option('sideblog_options');
	//delete_option('widget_sideblog');

}

function widget_sideblogwidget($args,$number=1){
	global $registered_widgets;
	extract($args);
	$options = get_option('widget_sideblog');
	$title = $options[$number]['title'];
	$category = $options[$number]['category'];

	if (empty($title))
		$title = '&nbsp;';
	echo "{$before_widget}{$before_title}{$title}{$after_title}<ul>";
	sideblog($category);
	echo "</ul>{$after_widget}";
}

function widget_sideblogwidget_control($number=1){
	global $wpdb;
	$options = $newoptions = get_option('widget_sideblog');
	if (isset($_POST["sideblog-submit-$number"])) {
		$newoptions[$number]['title'] = strip_tags(stripslashes($_POST["sideblog-title-$number"]));
		$newoptions[$number]['category'] = $_POST["sideblog-category-$number"];
	}
	if ($options != $newoptions) {
		$options = $newoptions;
		update_option('widget_sideblog', $options);
	}
	$title = htmlspecialchars($options[$number]['title'], ENT_QUOTES);

	$sideblog_options = get_option('sideblog_options');
	$rows = $wpdb->get_results("SELECT cat_ID as id, cat_name as name, category_nicename as slug FROM {$wpdb->categories} ORDER BY cat_name");

	$catlist = "";
	if($rows){
		foreach($rows as $row){
			if(isset($sideblog_options['setaside'][$row->id])){
				if($options[$number]['category']==$row->slug){ 
					$catlist .= "<option value=\"{$row->slug}\" selected=\"selected\">{$row->name}</option>";
				} else {
					$catlist .= "<option value=\"{$row->slug}\">{$row->name}</option>";
				}
			}
		}
	}

?>
	<input style="width: 250px;" id="sideblog-title-<?php echo "$number"; ?>" name="sideblog-title-<?php echo "$number"; ?>" type="text" value="<?php echo $title; ?>" />
	<select name="sideblog-category-<?php echo "$number"; ?>"><?php echo $catlist; ?></select>	
	<input type="hidden" id="sideblog-submit-<?php echo "$number"; ?>" name="sideblog-submit-<?php echo "$number"; ?>" value="1" />

<?php

}

function sideblog_widget_init(){
	global $registered_widgets;
	if(function_exists('register_sidebar_widget')){
		$sideblog_options = get_option('sideblog_options');
		if($sideblog_options['setaside']){
			$number = count($sideblog_options['setaside']);
			for($i=1;$i<=$number;$i++){
				$name = array('Sideblog %s',null,$i);
				register_sidebar_widget($name,'widget_sideblogwidget',$i);
				register_widget_control($name,'widget_sideblogwidget_control',300,200,$i);
			}
		}
	}
}

//A modified the_content_rss function
function sideblog_excerpt($content,$cut = 0, $encode_html = 0) {

	if ($cut && !$encode_html) {
		$encode_html = 2;
	}
	if ($encode_html == 1) {
		$content = wp_specialchars($content);
		$cut = 0;
	} elseif ($encode_html == 0) {
		$content = make_url_footnote($content);
	} elseif ($encode_html == 2) {
		$content = strip_tags($content);
	}
	if ($cut) {
		$blah = explode(' ', $content);
		if (count($blah) > $cut) {
			$k = $cut;
			$use_dotdotdot = 1;
		} else {
			$k = count($blah);
			$use_dotdotdot = 0;
		}
		for ($i=0; $i<$k; $i++) {
			$excerpt .= $blah[$i].' ';
		}
		$excerpt .= ($use_dotdotdot) ? '...' : '';
		$content = $excerpt;
	}
	$content = str_replace(']]>', ']]&gt;', $content);
	return $content;
}

add_filter('posts_where','sideblog_where');
add_filter('posts_join','sideblog_join');
add_action('admin_menu','sideblog_add_option_page');
register_activation_hook(__FILE__,'sideblog_install');
register_deactivation_hook(__FILE__,'sideblog_uninstall');
add_action('plugins_loaded','sideblog_widget_init');
?>